
const double _Rl      = 5000.0;               // Rl (Ohm) - Load resistance
const double _Vadc_5  = 0.0048828125;         // ADC step 5V/1024 4,88mV (10bit ADC)
const double _Vadc_33 = 0.0032226562;         // ADC step 3,3V/1024 3,22mV (10bit ADC)
double _Vrl;                                  // Output voltage
double _Rs;                                   // Rs (Ohm) - Sensor resistance
double _ppm;                                  // ppm
double _ratio;                                // Rs/Rl ratio
double _SupVoltage;

unsigned int _adc_rd;
bit V_Select;

unsigned int MQ_Analog(unsigned short Channel){

         unsigned int ADCVAL;

         return ADCVAL = ADC_Read(Channel);
}

double _calcAirQualityPPM(unsigned int adc_rd, const double Vadc){
  
        double lgPPM;
  
        _Vrl = (double)adc_rd * Vadc;                // For 5V Vcc use Vadc_5  and  for 3V Vcc use Vadc_33
        _Rs = _Rl * (5 - _Vrl)/_Vrl;                 // Calculate sensor resistance
        _ratio = _Rs/_Rl;                            // Calculate ratio
        lgPPM = (log10(_ratio) * -0.8)+ 0.9;         // Calculate ppm
  
        return _ppm = pow(10,lgPPM);                 // Calculate ppm
}

double _calcCOPPM(unsigned int adc_rd, const double Vadc){

       double lgPPM;
       
       _Vrl = (double)adc_rd * Vadc;
       _Rs = _Rl * (5 - _Vrl)/_Vrl;
       _ratio = _Rs/_Rl;                                // Calculate ratio
       lgPPM = (log10(_ratio) * -3.7)+ 0.9948;         // Calculate ppm

       return _ppm = pow(10,lgPPM);                    // Calculate ppm
}

double _calcLPGPPM(unsigned int adc_rd, const double Vadc) {
  
        double lgPPM;
  
       _Vrl = (double)adc_rd * Vadc;             // For 5V Vcc use Vadc_5  and  for 3V Vcc use Vadc_33
       _Rs = _Rl * (5 - _Vrl)/_Vrl;                   // Calculate sensor resistance
       _ratio = _Rs/_Rl;                             // Calculate ratio
       lgPPM = (log10(_ratio) * -2.8)+ 3.2;        // Calculate ppm
  
       return _ppm = pow(10,lgPPM);                       // Calculate ppm
}

double _calcAlcoholPPM(unsigned int adc_rd, const double Vadc) {
  
       double lgPPM;
       
       _Vrl = (double)adc_rd * Vadc;                    // For 5V Vcc use Vadc_5  and  for 3V Vcc use Vadc_33
       _Rs = _Rl * (5 - _Vrl)/_Vrl;                     // Calculate sensor resistance
       _ratio = _Rs/_Rl;                                // Calculate ratio
       lgPPM = (log10(_ratio) * -2.6)+ 2.7;             // Calculate ppm

       return _ppm = pow(10,lgPPM);                    // Calculate ppm
}